#
# pushare - P2P file sharing system
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: Search.pm,v 1.2 2004/06/05 02:04:07 fuktommy Exp $
#
package PuShare::Search;
use strict;
use PuShare::Config;
use PuShare::Util;

my $searchlist = $PuShare::Config::searchlist;

sub list() {
	my @search = ();
	if (open IN, $searchlist) {
		@search = <IN>;
		chomp @search;
		close IN;
	}
	return @search;
}

sub check(%) {
	my(%arg) = @_;
	if (rand() < $PuShare::Config::relay) {
		return 1;
	}
	my $s;
	my @search = list();
	foreach $s (@search) {
		my $flag = 0;
		eval "\$flag = ($s)";
		return 1 if ($flag);
	}
	return 0;
}

sub add($) {
	my($exp) = @_;
	PuShare::Util::lock();
	open OUT, ">> $searchlist" or return;
	print OUT "$exp\n";
	close OUT;	
	PuShare::Util::unlock();
}

sub delete($) {
	my($exp) = @_;
	PuShare::Util::lock();
	my @search = list();
	local $_;
	open OUT, "> $searchlist" or return;
	foreach (@search) {
		print OUT if ($_ ne $exp);
	}
	close OUT;	
	PuShare::Util::unlock();
}

1;
